GestorDeProyectos/urls.py
from django.conf.urls import url
from django.contrib import admin
from django.urls import path, include
from oauth_app.views import inicio
from django.contrib.auth.views import LogoutView

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', inicio, name='inicio'),
    path('accounts/', include('allauth.urls')),
    path('logout', LogoutView.as_view()),
    path('permisos/', include('oauth_app.urls')),
    path('proyectos/', include('Proyecto.urls')),

    #path denis, esta en mayuscula la P
    #path('Proyecto/', include('Proyecto.urls')),
]

Proyecto/urls.py
from django.urls import path
from .views import *
from Proyecto import views

app_name = 'Proyecto'
urlpatterns = [
    path('', views.index, name='index'),
    path('crear/', views.formCrearProyecto, name='crearProyecto'),
    path('crearRol/<int:id>', views.formCrearRolProyecto, name='crearRolProyecto'),
    path('editarRol/<int:id>', views.formEditarRolProyecto, name='editarRolProyecto'),
    path('verRol/<int:id>', views.formVerRolProyecto, name='verRolProyecto'),
    path('importar/<int:id>', views.listarProyectosRol, name='listarProyectosRol'),
    path('importar/<int:id>/<int:id_proyecto>', views.importarRolesProyectos, name='importarRolesProyectos'),
    path('editar/<int:id>', views.editProyecto, name='editarProyecto'),
    path('eliminar/<int:id>', views.deleteProyecto, name='eliminarProyecto'),
    path('guardarUs/<int:id>', FormularioNewUs, name="guardarUs"),
    path('usuarios/<int:id>', views.listaDeUsuarios, name="listaDeUsuarios"),

    # paths para cambiar el diseño de las pestañas para la vista de un proyecto
    path('ver/UsProyecto/<int:id>', views.UsProyecto, name="UsProyecto"),
    path('ver/DetallesProyecto/<int:id>', views.DetallesProyecto, name="DetallesProyecto"),
    path('ver/MiembrosProyecto/<int:id>', views.MiembrosProyecto, name="MiembrosProyecto"),
    path('ver/RolesProyecto/<int:id>', views.RolesProyecto, name="RolesProyecto"),
    # muestra el productBacklog de un proyecto
    path('ver/SprintProyecto/ListarUsSprintBacklog/<int:id>/<int:idSprint>', views.ListarUsSprintBacklog,
         name="ListarUsSprintBacklog"),
    # Agrega US como Sprint Planning
    path('ver/SprintProyecto/agregarSprintBacklog/<int:id>/<int:idSprint>/<int:idUs>', views.agregarSprintBacklog,
         name="agregarSprintBacklog"),
    # Para creacion de un nuevo sprint
    path('ver/SprintProyecto/Crear/<int:id>', views.CrearSprint, name="CrearSprint"),
    # listar sprint
    path('ver/SprintProyecto/<int:id>', views.ListarSprint, name="ListarSprint"),
    # ruta para verificar las cosas, previo a comenzar el sprint
    path('ver/SprintProyecto/VerificarSprint/<int:id>/<int:idSprint>', views.VerificarSprint, name="VerificarSprint"),

    # Url para agregar miembro a un proyecto (muestra solo los miembros que aun no estan en el proyecto)
    path('agregarMiembro/<int:id>/<int:socialUserId>', views.formCrearMiembro, name="agregarMiembros"),
    # Se muestran los datos del miembro del proyecto (rol y disponibilidad horaria)
    path('verMiembro/<int:id>/<int:miembroId>/<int:userAccId>', views.formVerMiembro, name="verMiembros"),
    # Se muestran los campos editables de un miembro en un proyecto (rol y disponibilidad horaria)
    path('editarMiembro/<int:id>/<int:miembroId>/<int:userAccId>', views.formEditarMiembro, name="editarMiembros"),
    # Boton para eliminar un miembro de un proyecto (rol y disponibilidad horaria)
    path('eliminarMiembro/<int:idProyecto>/<int:miembroId>', views.eliminarMiembroProyecto, name="eliminarMiembros"),

    # Boton para reemplazar un miembro de un proyecto
    path('reemplazarMiembro/<int:idProyecto>/<int:miembroViejoId>/<int:idPP>', views.reemplazarMiembroProyecto,
         name="reemplazarMiembro"),

    # Boton para reemplazar un miembro de un proyecto sin eliminarlo, solo reemplazarlo en una US
    path('reemplazarMiembroEnUS/<int:idProyecto>/<int:idUS>', views.reemplazarMiembroEnUSProyecto,
         name="reemplazarMiembroEnUS"),

    # Se reemplaza al US
    path('cambioDeMiembroAlReemplazarEnUs/<int:idProyecto>/<int:userNuevoId>/<int:idPP>',
         views.cambioDeMiembroAlReemplazarEnUs, name="cambioDeMiembroAlReemplazarEnUs"),

    # Al mostrarse las historias de usuario, se deben reemplazar por otro usuario activo del proyecto, esto posibles ususarios son mostrados con esta url
    path('cambioDeMiembroAlEliminar/<int:idProyecto>/<int:miembroViejoId>/<int:userNuevoId>/<int:idPP>',
         views.cambioDeMiembroAlEliminar, name="cambioDeMiembroAlEliminar"),

    # La ruta 'detalles' en donde mostraremos una página con los detalles de un us o registro
    # aqui se pasan por url el parametro que es el id que se requiere para recuperar un reigstro
    path('ver/detalle/<int:id>', UsDetalle.mostrarDetalle, name='detalle'),

    # La ruta 'actualizar' en donde mostraremos un formulario para actualizar un  registro de la Base de Datos
    # aqui se pasan por url el parametro que es el id que se requiere para recuperar un registro
    path('ver/actualizar/<int:id>', UsActualizar.editar, name='actualizar'),

    # para listar el SPrintBacklog de un sprint en planificacion
    path('ver/SprintProyecto/SprintBacklog/<int:id>/<int:idSprint>', views.ListarSprintBacklog,
         name="ListarSprintBacklog"),

    # para editar una planning poker
    path('ver/SprintProyecto/SprintBacklog/EditarPP/<int:id>/<int:idSprint>/<int:idPP>/<int:idUs>', views.EditarPP,
         name="EditarPlanningPoker"),

    # para quitar un US de un sprintbacklog
    path('ver/SprintProyecto/SprintBacklog/<int:id>/<int:idSprint>/<int:idPP>/<int:idUs>', views.QuitarSprintBacklog,
         name="QuitarSprintBacklog"),

    path('kanban/<int:id>/<int:volver>', views.indexKanban, name="verKanban"),

    # path de PRUEBA
    path('miembroprueba/<int:id>', views.obtenerMiembro),

    # path cuando se desea agregar actividad
    path('kanban/agregarActividad/<int:id>/<int:idSprint>/<int:idUs>/<int:volver>', views.agregarActividad,
         name='agregarActividad'),

    # path para cuando se desea ver el historial de modificaciones
    path('kanban/historialMod/<int:idUs>', views.historialMod, name='historialMod'),

    # path para cuando se desea ver el historial
    path('kanban/historialUs/<int:id>/<int:idUs>/<int:volver>/<int:kanbanvolver>/<int:idSprint>', views.historialUs,
         name='historialUs'),

    # Retorna un json con los datos necesarios para el chart
    path('burndownchartjson/<int:idSprint>', views.burndownChart, name='burndownChartjson'),

    # Despliega el burndown del sprint correspondiente
    path('burndownchart/<int:idSprint>', views.burndownChartIndex, name='burndownChart'),

    # Confirmacion de Finalizar un proyecto
    path('ver/confirmarFinalizarProyecto/<int:id>', views.confirmarFinalizarProyecto,
         name='confirmarFinalizarProyecto'),

    # Finalizar un proyecto, por el ID
    path('ver/finalizarProyecto/<int:id>', views.finalizarProyecto, name='finalizarProyecto'),

    # path para desplegar el resumen cuando se termina un sprint
    path('ver/resumenFinSprint/<int:id>/<int:idSprint>', views.resumenFinSprint, name='resumenFinSprint'),

    # path para terminar el sprint y hacer algunos ajustes en los datos
    path('ver/resumen/<int:id>/<int:idSprint>', views.resumenFinSprint, name='resumenFinSprint'),
    path('SprintProyecto/<int:id>/<int:idSprint>', views.finSprint, name='finSprint'),

    # path para editar una actividad
    path(
        'kanban/historialUs/editar/<int:id>/<int:idSprint>/<int:idUs>/<int:volver>/<int:idActividad>/<int:volverkanban>',
        views.editarActividadUs, name='editarActividadUs'),

    # path para los pdf
    # para listar el Sprint Backlog de un sprint en planificacion
    path('listUserStoryPdf/<int:idSprint>/', views.listUserStoryPdf, name="listUserStoryPdf"),

    # para listar el Product Backlog de un proyecto
    path('listProductBacklogPdf/<int:idProyecto>/', views.listProductBacklogPdf, name="listProductBacklogPdf"),

    # para listar los US del sprint actual de un proyecto
    path('listUsSprintActualPdf/<int:idProyecto>/', views.listUsSprintActualPdf, name="listUsSprintActualPdf"),

    # para ver los miembros de un sprint
    path('miembroSprint/<int:idSprint>/', views.miembroEnSprint, name="miembrosSprint"),

]

templates/Desarrollo/Sprint/CrearSprint.html
{% extends 'base.html' %}
{% load crispy_forms_tags %}
{% block nav-proyecto %}
    <li class="nav-item active">
        <a class="nav-link" href="{% url 'Proyecto:index' %}">Proyecto <span class="sr-only">(current)</span> </a>
    </li>
{% endblock %}
{% block content %}

    {% if form.errors %}
        <div class="alert alert-danger" role="alert">
            ERROR AL GUARDAR
        </div>
    {% endif %}

    <div class="container mb-5">
        <div class="py-5 text-center ">
            <h1 class="text-light"> Crear Nuevo Sprint </h1>
        </div>
        <div id="cantSprintPendientes" class="alert alert-warning d-flex align-items-center m-2" role="alert">
            <svg class="bi flex-shrink-0 me-2" width="24" height="24" role="img" aria-label="Warning:">
                <use xlink:href="#exclamation-triangle-fill"/>
            </svg>
            <div>
                Ya cuenta con un Sprint pendiente
            </div>
        </div>
        <div id="idAlertaRangoFecha" style="display: none;">
            <div class="alert alert-warning d-flex align-items-center" role="alert">
                <svg class="bi flex-shrink-0 me-2 m-3" width="24" height="24" role="img" aria-label="Warning:">
                    <use xlink:href="#exclamation-triangle-fill"></use>
                </svg>
                <div>
                    Advertencia : Rango de fecha invalida
                </div>
            </div>
        </div>

        <!-- escribir aqui -->
        <div class="bg-light border rounded border-dark p-3">

            <form method="POST">
                {% csrf_token %}
                {{ formSprint|crispy }}
                <button id="btnIniciarSprint" type="submit"
                        class="btn btn-primary {% if cantSprintPend > 0 %} disabled {% endif %}">
                    Guardar
                </button>
                <a class="btn btn-secondary" href="{% url 'Proyecto:ListarSprint' idProyecto %}"
                   role="button">Cancelar</a>
            </form>
        </div>


    </div>

    <script>

        // Función externa para calcular si le alcanza el tiempo
        function calcularFecha() {
            if (document.getElementById('id_fechaInicio').value != null && document.getElementById('id_fechaFin').value != null) {
                // traemos obtenemos las fechas
                var fechaini = new Date($("#id_fechaInicio").val() + "T00:00:00");
                var fechafin = new Date($("#id_fechaFin").val() + "T00:00:00");
                var dia = 0;
                var mes = 0;
                var ano = 0;
                {% if ultimoSprint.fechaFin %}
                    var dia = {{ ultimoSprint.fechaFin.day }};
                    var mes ={{ ultimoSprint.fechaFin.month }};
                    var ano ={{ ultimoSprint.fechaFin.year }};
                {% endif%}
                if (dia < 10) dia = "0" + dia.toString();
                if (mes < 10) mes = "0" + mes.toString();
                if (ano < 10) ano = "0" + ano.toString();
                var fechaMinimo = new Date(ano + "-" + mes + "-" + dia + "T00:00:00");
                document.getElementById("btnIniciarSprint").disabled = true;
                if (fechaini <= fechaMinimo || fechafin <= fechaMinimo) {
                    document.getElementById("btnIniciarSprint").disabled = true;
                    document.getElementById("idAlertaRangoFecha").style.display = "block";
                } else {
                    if (fechafin <= fechaini) {
                        document.getElementById("btnIniciarSprint").disabled = true;
                        document.getElementById("idAlertaRangoFecha").style.display = "block";
                    } else {
                        document.getElementById("idAlertaRangoFecha").style.display = "none";
                        document.getElementById("btnIniciarSprint").disabled = false;
                    }
                }

            } else {
                console.log('Hace algo else');
            }
        }

        window.onload = function () {
            calcularFecha();
        }

        // Asignar la función externa al elemento
        document.getElementById("id_fechaInicio").onchange = calcularFecha;
        document.getElementById("id_fechaFin").onchange = calcularFecha;


        if ({{ cantSprintPend }} >
        0
        )
        {
            document.getElementById("cantSprintPendientes").style.visibility = "visible";
        }
        else
        {
            document.getElementById("cantSprintPendientes").style.visibility = "hidden";
        }


    </script>
{% endblock %}

templates/Desarrollo/Sprint/ResumenFinSprint.html
{% extends 'base.html' %}
{% load crispy_forms_tags %}
{% load custom_tags %}
{% block content %}
    <div class="container">
        <br>
        <br>
        <div class="bg-light rounded border-dark p-3">
            <h3>Resumen Us del sprint</h3>
            <table class="table table-bordered ">
                <thead>
                <tr>
                    <th scope="col">User Story</th>
                    <th scope="col">Prioridad</th>
                    <th scope="col">Estimacion</th>
                    <th scope="col">Tiempo dedicado</th>
                    <th scope="col">Estado</th>
                    <th scope="col">Encargado</th>
                </tr>
                </thead>
                <tbody>
                {% for pp in listUs %}
                    <tr>
                        <td>{{ pp.idUs.titulo }}</td>
                        <td>{{ pp.prioridad }}</td>
                        <td>
                            {% if pp.estimacionFinal %}
                                {{ pp.estimacionFinal }}
                            {% else %}
                                No Estimado
                            {% endif %}
                        </td>
                        <td>{{ pp.idUs.tiempoDedicado }}</td>
                        <td>{{ pp.idUs.estado }}</td>
                        <td>{{ pp.miembroEncargado }}</td>
                    </tr>
                {% endfor %}
                </tbody>
            </table>

        {% if  bandUsH == True %}
            <div class="alert alert-warning" role="alert">
                Algunas US que deben ser evaluadas para terminar el sprint. Las US terminadas deben de ser aprobadas o rechazadas.
            </div>
        {% endif %}

            Desea terminar el Sprint?
            <div class="bg-light border rounded border-light">
                <a class="btn btn-primary {% if  bandUsH == True %}disabled{% endif %}" href="{% url 'Proyecto:finSprint' idProyecto idSprint %}"
                   role="button" >Confirmar</a>
                <a class="btn btn-secondary" href="{% url 'Proyecto:ListarSprint' idProyecto %}"
                   role="button">Volver</a>

            </div>
        </div>


    </div>






{% endblock %}

templates/Desarrollo/Sprint/VerificacionSprint.html
{% extends 'base.html' %}
{% load crispy_forms_tags %}
{% block content %}
    <div class="container mb-5">
        <br>
        <br>
        <div class="bg-light rounded border-dark p-3">
            <h4>Sprint a iniciar</h4>
            <table class="table table-bordered ">
                <tbody>
                <tr>
                    <th scope="row" style="width:40%" style="width:40%">Numero de Sprint:</th>
                    <td>{{ sprint.numero }}</td>
                </tr>
                <tr>
                    <th scope="row" style="width:40%">Cantidad de horas de trabajo aproximado:</th>
                    <td>{{ horastrabajo }}</td>
                </tr>
                <tr>
                    <th scope="row" style="width:40%">Cantidad de horas de trabajo semanal de equipo</th>
                    <td>{{ cargasemanal }}</td>
                </tr>
                <tr>
                    <th scope="row" style="width:40%">Fecha de inicio</th>
                    <td>{{ sprint.fechaInicio }}</td>
                </tr>
                <tr>
                    <th scope="row" style="width:40%">Fecha de fin</th>
                    <td>{{ sprint.fechaFin }}</td>
                </tr>
                </tbody>
            </table>

            <h3>Sprint Backlog</h3>
            <table class="table table-bordered ">
                <thead>
                <tr>
                    <th scope="col">User Story</th>
                    <th scope="col">Prioridad</th>
                    <th scope="col">Estimacion</th>
                    <th scope="col">Encargado</th>
                </tr>
                </thead>
                <tbody>
                {% for pp in listUs %}
                    <tr>
                        <td>{{ pp.idUs.titulo }}</td>
                        <td>{{ pp.prioridad }}</td>
                        <td>
                            {% if pp.estimacionFinal %}
                                {{ pp.estimacionFinal }}
                            {% else %}
                                No Estimado
                            {% endif %}
                        </td>
                        <td>{{ pp.miembroEncargado }}</td>
                    </tr>
                {% endfor %}
                </tbody>
            </table>


            <div class="bg-light border rounded border-light">
                <div id="idAlertDiv" style="display: none;">
                    <div class="alert alert-warning d-flex align-items-center" role="alert">
                        <svg class="bi flex-shrink-0 me-2 m-3" width="24" height="24" role="img" aria-label="Warning:">
                            <use xlink:href="#exclamation-triangle-fill"></use>
                        </svg>
                        <div>
                            Advertencia : La cantidad de dias para completar el Sprint es reducido. Recomendamos que
                            aumente el rango de fecha.
                        </div>
                    </div>
                </div>
                <div id="idAlertfechaMenor" style="display: none;">
                    <div class="alert alert-warning d-flex align-items-center" role="alert">
                        <svg class="bi flex-shrink-0 me-2 m-3" width="24" height="24" role="img" aria-label="Warning:">
                            <use xlink:href="#exclamation-triangle-fill"></use>
                        </svg>
                        <div>
                            Advertencia : Seleccione una fecha de finalizacion posterior a la fecha de inicio
                        </div>
                    </div>
                </div>
                <form method="POST">
                    {{ formfecha|crispy }}
                    {% csrf_token %}
                    {% if puedeIniciar %}
                        <button id="btnIniciarSprint" type="submit" class="btn btn-primary">Iniciar</button>
                    {% else %}
                        <div class="alert alert-danger" role="alert">
                            No se Puede Iniciar este Sprint
                        </div>
                    {% endif %}
                    <a class="btn btn-secondary" href="{% url 'Proyecto:ListarSprint' idProyecto %}"
                       role="button">Volver</a>
                </form>
            </div>
        </div>


    </div>

    <script>
        // Función externa para calcular si le alcanza el tiempo
        function calcularTiempo() {
            if (document.getElementById('id_fechaInicio').value != null && document.getElementById('id_fechaFin').value != null) {
                // traemos obtenemos las fechas
                var fechaini = new Date($("#id_fechaInicio").val() + "T00:00:00");
                var fechafin = new Date($("#id_fechaFin").val() + "T00:00:00");
                var diasdif = fechafin.getTime() - fechaini.getTime();

                // cantidad de dias entre las dos fechas
                var cantdias = Math.round(diasdif / (1000 * 60 * 60 * 24));

                // Cantidad de horas que se trabajara
                var horaTrabajoPosible = cantdias / 7 *{{ cargasemanal }};
                horaTrabajoPosible = Math.round(horaTrabajoPosible);

                // Cant de horas a trabajar);
                var horastrabajo = {{ horastrabajo }};

                if (diasdif <= 0) {
                    document.getElementById("btnIniciarSprint").disabled = true;
                    document.getElementById("idAlertfechaMenor").style.display = "block";
                } else {
                    document.getElementById("btnIniciarSprint").disabled = false;
                    document.getElementById("idAlertfechaMenor").style.display = "none";
                    // la horas de a trabajar es > a horas de trabajo posible, mostar div con alerta
                    if (horastrabajo > horaTrabajoPosible) {
                        document.getElementById("idAlertDiv").style.display = "block";
                    } else {
                        document.getElementById("idAlertDiv").style.display = "none";
                    }
                }

            }
        }

        window.onload = function () {
            calcularTiempo();
        }

        // Asignar la función externa al elemento
        document.getElementById("id_fechaInicio").onchange = calcularTiempo;
        document.getElementById("id_fechaFin").onchange = calcularTiempo;

    </script>




{% endblock %}

templates/Desarrollo/Sprint/viewSprintBacklog.html
{% extends 'base.html' %}
{% load crispy_forms_tags %}
{% load custom_tags %}
{% block content %}
    <div class="container mb-5">

        <div class="py-5 text-center ">
            <h1 class="text-light"> Sprint Backlog </h1>
        </div>

        <div class="bg-light rounded border-dark p-3">
            <div class="input-group">
                <input type="text" id="buscarUS" onkeyup="buscarTabla('buscarUS','tablaSprintB')"
                       placeholder="Buscar por User Story"
                       title="Escriba un rol" class="form-control m-3" aria-describedby="inputGroup-sizing-lg">
            </div>
            <table class="table table-hover " id="tablaSprintB">
                <thead class="thead-dark">
                <tr>
                    <th onclick="sortTable(0,'tablaSprintB','String')">User Story</th>
                    <th onclick="sortTable(1,'tablaSprintB','Numero')">Prioridad</th>
                    <th onclick="sortTable(2,'tablaSprintB','Numero')">Estimacion</th>
                    <th onclick="sortTable(3,'tablaSprintB','String')">Encargado</th>
                    <th onclick="sortTable(4,'tablaSprintB','Numero')">Horas Trabajadas</th>
                    {% if sprint.estado == 'P' %}
                        <th scope="col">Acciones</th>
                    {% endif %}
                </tr>
                </thead>
                <tbody>
                {% for pp in listUs %}
                    <tr>
                        <td>{{ pp.idUs.titulo }}</td>
                        <td>{{ pp.prioridad }}</td>
                        <td>
                            {% if pp.estimacionFinal %}
                                {{ pp.estimacionFinal }}
                            {% else %}
                                No Estimado
                            {% endif %}
                        </td>
                        <td>{{ pp.miembroEncargado.idUser.first_name }} {{ pp.miembroEncargado.idUser.last_name }}</td>
                        <td>{{ pp.idUs.tiempoDedicado }}</td>
                        {% if sprint.estado == 'P' %}
                            <td>
                                <form method="POST" action="">
                                    {% csrf_token %}

                                    <div class="btn-group">
                                        <a href="{% url 'Proyecto:EditarPlanningPoker' idProyecto idSprint pp.id pp.idUs.id %}"
                                           type="button"
                                           class="btn btn-info

                                                   {% if permisos %}{% if not permisos|get_at_index:13 %} disabled {% endif %}{% endif %}">
                                            Editar</a>
                                        <a href="{% url 'Proyecto:QuitarSprintBacklog' idProyecto idSprint pp.id pp.idUs.id %}"
                                           type="button"
                                           class="btn btn-danger">Quitar</a>
                                    </div>
                                </form>

                            </td>
                        {% endif %}
                    </tr>
                {% endfor %}
                </tbody>
            </table>


            <div class="bg-light border rounded border-light">
                <a class="btn btn-secondary" href="{% url 'Proyecto:listUserStoryPdf' idSprint %}"
                   role="button">Sprint Backlog PDF</a>
                <a class="btn btn-secondary" href="{% url 'Proyecto:ListarSprint' idProyecto %}"
                   role="button">Volver</a>
            </div>
        </div>


    </div>






{% endblock %}